﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Diagnostics;
using Infragistics.Win;
using Infragistics.Win.UltraWinEditors;
using Infragistics.Win.UltraMessageBox;

namespace WindowsFormsApplication2
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            var stream = this.GetType().Assembly.GetManifestResourceStream("WindowsFormsApplication2.Image1.png");
            var image = Image.FromStream(stream);
            this.ultraTextEditor1.Appearance.Image = image;
            this.ultraTextEditor1.Appearance.ImageHAlign = Infragistics.Win.HAlign.Left;
            this.ultraTextEditor1.Appearance.ImageVAlign = Infragistics.Win.VAlign.Top;

            this.ultraTextEditor1.CreationFilter = new ImageMovingCreationFilter();
        }

        private void ultraTextEditor1_MouseUp(object sender, MouseEventArgs e)
        {
            var textEditor = (UltraTextEditor)sender;
            UIElement element = textEditor.UIElement.LastElementEntered;

            var imageElement = element as ImageUIElement;
            if (null == imageElement)
                imageElement = element.GetAncestor(typeof(ImageUIElement)) as ImageUIElement;

            if (null == imageElement)
                return;

            UltraMessageBoxManager.Show(this, "You just clicked on the image.");
            
        }
    }

    public class ImageMovingCreationFilter : IUIElementCreationFilter
    {
        void IUIElementCreationFilter.AfterCreateChildElements(UIElement parent)
        {
            if (parent is EditorWithTextUIElement)
            {
                // This movies the image into the upper left corner of the control, which is pretty
                // much where it already was, but it's ignoring all borders and margins, now. 
                var imageElement = parent.GetDescendant(typeof(ImageUIElement)) as ImageUIElement;
                imageElement.Rect = new Rectangle(parent.Rect.Location, imageElement.Rect.Size);
            }
        }

        bool IUIElementCreationFilter.BeforeCreateChildElements(UIElement parent)
        {
            // Do nothing. 
            return false;
        }
    }
}
